Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/AMM12/EXP00/namelist
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3403)
@@ -137,4 +137,7 @@
                            !  =1 use observed ice-cover      ,
                            !  =2 ice-model used                         ("key_lim3" or "key_lim2)
+   nn_ice_embd = 0         !  =0 levitating ice (no mass exchange, concentration/dilution effect)
+                           !  =1 levitating ice with mass and salt exchange but no presure effect
+                           !  =2 embedded sea-ice (full salt and mass exchanges and pressure)
    ln_dm2dc    = .false.   !  daily mean to diurnal cycle on short wave
    ln_rnf      = .true.    !  runoffs                                   (T => fill namsbc_rnf)
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist	(revision 3403)
@@ -137,4 +137,7 @@
                            !  =1 use observed ice-cover      ,
                            !  =2 ice-model used                         ("key_lim3" or "key_lim2)
+   nn_ice_embd = 0         !  =0 levitating ice (no mass exchange, concentration/dilution effect)
+                           !  =1 levitating ice with mass and salt exchange but no presure effect
+                           !  =2 embedded sea-ice (full salt and mass exchanges and pressure)
    ln_dm2dc    = .false.   !  daily mean to diurnal cycle on short wave
    ln_rnf      = .true.    !  runoffs                                   (T => fill namsbc_rnf)
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3403)
@@ -137,4 +137,7 @@
                            !  =1 use observed ice-cover      ,
                            !  =2 ice-model used                         ("key_lim3" or "key_lim2)
+   nn_ice_embd = 0         !  =0 levitating ice (no mass exchange, concentration/dilution effect)
+                           !  =1 levitating ice with mass and salt exchange but no presure effect
+                           !  =2 embedded sea-ice (full salt and mass exchanges and pressure)
    ln_dm2dc    = .false.   !  daily mean to diurnal cycle on short wave
    ln_rnf      = .false.   !  runoffs                                   (T => fill namsbc_rnf)
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3403)
@@ -137,4 +137,7 @@
                            !  =1 use observed ice-cover      ,
                            !  =2 ice-model used                         ("key_lim3" or "key_lim2)
+   nn_ice_embd = 0         !  =0 levitating ice (no mass exchange, concentration/dilution effect)
+                           !  =1 levitating ice with mass and salt exchange but no presure effect
+                           !  =2 embedded sea-ice (full salt and mass exchanges and pressure)
    ln_dm2dc    = .false.   !  daily mean to diurnal cycle on short wave
    ln_rnf      = .true.    !  runoffs                                   (T => fill namsbc_rnf)
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3403)
@@ -137,4 +137,7 @@
                            !  =1 use observed ice-cover      ,
                            !  =2 ice-model used                         ("key_lim3" or "key_lim2)
+   nn_ice_embd = 0         !  =0 levitating ice (no mass exchange, concentration/dilution effect)
+                           !  =1 levitating ice with mass and salt exchange but no presure effect
+                           !  =2 embedded sea-ice (full salt and mass exchanges and pressure)
    ln_dm2dc    = .false.   !  daily mean to diurnal cycle on short wave
    ln_rnf      = .true.    !  runoffs                                   (T => fill namsbc_rnf)
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 3403)
@@ -63,5 +63,5 @@
       REAL(wp) ::   zsrau, zse3t   ! temporary scalars
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zemps
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: zsfx
       REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrtrd
       !!---------------------------------------------------------------------
@@ -70,5 +70,5 @@
       !
       ! Allocate temporary workspace
-                      CALL wrk_alloc( jpi, jpj,      zemps  )
+                      CALL wrk_alloc( jpi, jpj,      zsfx   )
       IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrtrd )
 
@@ -80,13 +80,13 @@
 
 
-      IF( lk_offline ) THEN          ! emps in dynamical files contains emps - rnf
-         zemps(:,:) = emps(:,:)  
+      IF( lk_offline ) THEN          ! sfx in dynamical files contains sfx  - rnf
+         zsfx(:,:) = sfx(:,:)  
       ELSE                           ! Concentration dilution effect on tracer due to evaporation, precipitation, and river runoff
          IF( lk_vvl ) THEN                      ! volume variable
-            zemps(:,:) = emps(:,:) - emp(:,:)   
-!!ch         zemps(:,:) = 0.
+            zsfx(:,:) = sfx(:,:) - emp(:,:)   
+!!ch         zsfx(:,:) = 0.
          ELSE                                   ! linear free surface
-            IF( ln_rnf ) THEN  ;  zemps(:,:) = emps(:,:) - rnf(:,:)   !  E-P-R
-            ELSE               ;  zemps(:,:) = emps(:,:)
+            IF( ln_rnf ) THEN  ;  zsfx(:,:) = sfx(:,:) - rnf(:,:)   !  E-P-R
+            ELSE               ;  zsfx(:,:) = sfx(:,:)
             ENDIF 
          ENDIF 
@@ -102,5 +102,5 @@
             DO ji = fs_2, fs_jpim1   ! vector opt.
                zse3t = 1. / fse3t(ji,jj,1)
-               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zemps(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
+               tra(ji,jj,1,jn) = tra(ji,jj,1,jn) + zsfx(ji,jj) *  zsrau * trn(ji,jj,1,jn) * zse3t
             END DO
          END DO
@@ -117,5 +117,5 @@
                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
-                      CALL wrk_dealloc( jpi, jpj,      zemps  )
+                      CALL wrk_dealloc( jpi, jpj,      zsfx   )
       IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, jpk, ztrtrd )
       !
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 3403)
@@ -227,5 +227,5 @@
    USE sbc_oce , ONLY :   emp        =>    emp        !: freshwater budget: volume flux               [Kg/m2/s]
    USE sbc_oce , ONLY :   emp_b      =>    emp_b      !: freshwater budget: volume flux               [Kg/m2/s]
-   USE sbc_oce , ONLY :   emps       =>    emps       !: freshwater budget: concentration/dillution   [Kg/m2/s]
+   USE sbc_oce , ONLY :   sfx        =>    sfx        !: freshwater budget: concentration/dillution   [Kg/m2/s]
    USE sbc_oce , ONLY :   rnf        =>    rnf        !: river runoff   [Kg/m2/s]
    USE sbc_oce , ONLY :   ln_dm2dc   =>    ln_dm2dc   !: Daily mean to Diurnal Cycle short wave (qsr) 
Index: branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 3402)
+++ branches/2012/dev_r3385_NOCS04_HAMF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 3403)
@@ -121,5 +121,5 @@
           fr_i_tm  (:,:)         = fr_i_tm  (:,:)         + fr_i  (:,:)
           emp_tm   (:,:)         = emp_tm   (:,:)         + emp   (:,:) 
-          emps_tm  (:,:)         = emps_tm  (:,:)         + emps  (:,:)
+          emps_tm  (:,:)         = emps_tm  (:,:)         + sfx   (:,:)
           qsr_tm   (:,:)         = qsr_tm   (:,:)         + qsr   (:,:)
           wndm_tm  (:,:)         = wndm_tm  (:,:)         + wndm  (:,:)
@@ -209,5 +209,5 @@
          emp_temp   (:,:)        = emp   (:,:)
          emp_b_temp (:,:)        = emp_b (:,:)
-         emps_temp  (:,:)        = emps  (:,:)
+         emps_temp  (:,:)        = sfx   (:,:)
          qsr_temp   (:,:)        = qsr   (:,:)
          wndm_temp  (:,:)        = wndm  (:,:)
@@ -313,5 +313,5 @@
          fr_i_tm  (:,:)          = fr_i_tm    (:,:)       + fr_i  (:,:)
          emp_tm   (:,:)          = emp_tm     (:,:)       + emp   (:,:) 
-         emps_tm  (:,:)          = emps_tm    (:,:)       + emps  (:,:)
+         emps_tm  (:,:)          = emps_tm    (:,:)       + sfx   (:,:)
          qsr_tm   (:,:)          = qsr_tm     (:,:)       + qsr   (:,:)
          wndm_tm  (:,:)          = wndm_tm    (:,:)       + wndm  (:,:)
@@ -332,5 +332,5 @@
             qsr   (:,:)          = qsr_tm     (:,:) * r1_ndttrc 
             emp   (:,:)          = emp_tm     (:,:) * r1_ndttrc 
-            emps  (:,:)          = emps_tm    (:,:) * r1_ndttrc 
+            sfx   (:,:)          = emps_tm    (:,:) * r1_ndttrc 
             fr_i  (:,:)          = fr_i_tm    (:,:) * r1_ndttrc
 # if defined key_trabbl
@@ -348,5 +348,5 @@
             qsr   (:,:)          = qsr_tm     (:,:) * r1_ndttrcp1 
             emp   (:,:)          = emp_tm     (:,:) * r1_ndttrcp1 
-            emps  (:,:)          = emps_tm    (:,:) * r1_ndttrcp1 
+            sfx   (:,:)          = emps_tm    (:,:) * r1_ndttrcp1 
             fr_i  (:,:)          = fr_i_tm    (:,:) * r1_ndttrcp1 
 # if defined key_trabbl
@@ -498,5 +498,5 @@
          CALL lbc_lnk( emp   (:,:)         , 'T', 1. ) 
          CALL lbc_lnk( emp_b (:,:)         , 'T', 1. ) 
-         CALL lbc_lnk( emps  (:,:)         , 'T', 1. ) 
+         CALL lbc_lnk( sfx   (:,:)         , 'T', 1. ) 
          CALL lbc_lnk( qsr   (:,:)         , 'T', 1. ) 
          CALL lbc_lnk( wndm  (:,:)         , 'T', 1. ) 
@@ -705,5 +705,5 @@
       fr_i  (:,:)     =  fr_i_temp  (:,:)
       emp   (:,:)     =  emp_temp   (:,:)
-      emps  (:,:)     =  emps_temp  (:,:)
+      sfx   (:,:)     =  emps_temp  (:,:)
       emp_b (:,:)     =  emp_b_temp (:,:)
       qsr   (:,:)     =  qsr_temp   (:,:)
@@ -824,5 +824,5 @@
       fr_i_tm    (:,:) = fr_i  (:,:)
       emp_tm     (:,:) = emp   (:,:)
-      emps_tm    (:,:) = emps  (:,:)
+      emps_tm    (:,:) = sfx   (:,:)
       qsr_tm     (:,:) = qsr   (:,:)
       wndm_tm    (:,:) = wndm  (:,:)