Index: /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/AMM12/EXP00/namelist
===================================================================
--- /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3435)
+++ /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/AMM12/EXP00/namelist	(revision 3436)
@@ -897,7 +897,7 @@
                            !     ln_ssh                  Logical switch for SSH observations              
 
-   ln_sst     = .false.    ! Logical switch for SST observations              
-                           !     ln_reysst               Logical switch for Reynolds observations       
-                           !     ln_ghrsst               Logical switch for GHRSST observations          
+   ln_sst     = .true.     ! Logical switch for SST observations
+   ln_reysst  = .true.     !     ln_reysst               Logical switch for Reynolds observations
+   ln_ghrsst  = .false.    !     ln_ghrsst               Logical switch for GHRSST observations      
 
    ln_sstfb   = .false.    ! Logical switch for feedback SST data          
Index: /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist
===================================================================
--- /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist	(revision 3435)
+++ /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/AMM12_PISCES/EXP00/namelist	(revision 3436)
@@ -898,7 +898,7 @@
                            !     ln_ssh                  Logical switch for SSH observations              
 
-   ln_sst     = .false.    ! Logical switch for SST observations              
-                           !     ln_reysst               Logical switch for Reynolds observations       
-                           !     ln_ghrsst               Logical switch for GHRSST observations          
+   ln_sst     = .true.     ! Logical switch for SST observations
+   ln_reysst  = .true.     !     ln_reysst               Logical switch for Reynolds observations
+   ln_ghrsst  = .false.    !     ln_ghrsst               Logical switch for GHRSST observations      
 
    ln_sstfb   = .false.    ! Logical switch for feedback SST data          
Index: /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/GYRE/EXP00/namelist
===================================================================
--- /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3435)
+++ /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/GYRE/EXP00/namelist	(revision 3436)
@@ -889,7 +889,7 @@
                            !     ln_ssh                  Logical switch for SSH observations              
 
-   ln_sst     = .false.    ! Logical switch for SST observations              
-                           !     ln_reysst               Logical switch for Reynolds observations       
-                           !     ln_ghrsst               Logical switch for GHRSST observations          
+   ln_sst     = .true.     ! Logical switch for SST observations              
+   ln_reysst  = .true.     !     ln_reysst               Logical switch for Reynolds observations       
+   ln_ghrsst  = .false.    !     ln_ghrsst               Logical switch for GHRSST observations          
 
    ln_sstfb   = .false.    ! Logical switch for feedback SST data          
Index: /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist
===================================================================
--- /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3435)
+++ /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/ORCA2_LIM/EXP00/namelist	(revision 3436)
@@ -893,7 +893,7 @@
                            !     ln_ssh                  Logical switch for SSH observations              
 
-   ln_sst     = .false.    ! Logical switch for SST observations              
-   ln_reysst  = .false.    !     ln_reysst               Logical switch for Reynolds observations       
-                           !     ln_ghrsst               Logical switch for GHRSST observations          
+   ln_sst     = .true.     ! Logical switch for SST observations
+   ln_reysst  = .true.     !     ln_reysst               Logical switch for Reynolds observations
+   ln_ghrsst  = .false.    !     ln_ghrsst               Logical switch for GHRSST observations      
 
    ln_sstfb   = .false.    ! Logical switch for feedback SST data          
Index: /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist
===================================================================
--- /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3435)
+++ /branches/2012/dev_r3342_MERCATOR7_SST/NEMOGCM/CONFIG/ORCA2_OFF_PISCES/EXP00/namelist	(revision 3436)
@@ -890,7 +890,7 @@
                            !     ln_ssh                  Logical switch for SSH observations              
 
-   ln_sst     = .false.    ! Logical switch for SST observations              
-                           !     ln_reysst               Logical switch for Reynolds observations       
-                           !     ln_ghrsst               Logical switch for GHRSST observations          
+   ln_sst     = .true.     ! Logical switch for SST observations
+   ln_reysst  = .true.     !     ln_reysst               Logical switch for Reynolds observations
+   ln_ghrsst  = .false.    !     ln_ghrsst               Logical switch for GHRSST observations      
 
    ln_sstfb   = .false.    ! Logical switch for feedback SST data          