Index: /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/ARCH/CNRS/arch-ALTIX_JADE.fcm
===================================================================
--- /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/ARCH/CNRS/arch-ALTIX_JADE.fcm	(revision 3458)
+++ /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/ARCH/CNRS/arch-ALTIX_JADE.fcm	(revision 3459)
@@ -28,2 +28,14 @@
 %USER_INC            %NCDF_INC
 %USER_LIB            %NCDF_LIB
+
+# Flags only needed for IOSERVER
+%CC      icc
+%XIO_CFLAGS    -ansi -O3 -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279 -D BOOST_DISABLE_ASSERTS -DMPI_NO_CPPBIND
+%XIO_FFLAGS    -O3 -DXIOS_LIBRARY
+%XIO_LD         ifort
+%XIO_LDFLAGS        -lstdc++ -lifcore -lintlc -lmpi    
+%XIO_INC       
+
+%XIO_CINC     -I/opt/software/SGI/hdf5/1.8.6/include  -I/opt/software/SGI/netcdf/4.1.3/include
+%XIO_FINC
+%XIO_LDINC     -L/opt/software/SGI/netcdf/4.1.3/lib -L/opt/software/SGI/hdf5/1.8.6/lib   -lnetcdff -lnetcdf -lhdf5_hl -lhdf5 -lhdf5 -lz 
Index: /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/ARCH/CNRS/arch-X64_CURIE.fcm
===================================================================
--- /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/ARCH/CNRS/arch-X64_CURIE.fcm	(revision 3458)
+++ /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/ARCH/CNRS/arch-X64_CURIE.fcm	(revision 3459)
@@ -1,3 +1,3 @@
-# Curie BULL at french TGCC, http://www-hpc.cea.fr/en/complexe/tgcc-curie.htm
+# ifort compiler options for CINES SGI-ALTIX Jade, http://www.cines.fr/spip.php?rubrique291
 # NCDF_INC    netcdf include file
 # NCDF_LIB    netcdf library
@@ -13,32 +13,30 @@
 # USER_INC    additional include files for the compiler,  e.g. -I<include dir>
 # USER_LIB    additional libraries to pass to the linker, e.g. -l<library>
-# here NETCDF_INC_DIR, HDF5_INC_DIR are variables relative to this compiler exported before
 
-%NCDF_INC            -I$(NETCDF_INC_DIR)
-%NCDF_LIB            -L$(NETCDF_LIB_DIR) -L$HDF5_LIB_DIR    -lnetcdff -lnetcdf -lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl -lstdc++
-%FC                  mpif90 -c -cpp
-# for Curie Fat Node
-%FCFLAGS             -i4 -r8 
-# for Curie Thin Node
-#%FCFLAGS             -i4 -r8 -fast -xAVX   -automatic
-%FFLAGS              %FCFLAGS
-%LD                  mpif90
+
+%NCDF_INC            -I/opt/software/SGI/netcdf/4.1.3/include
+%NCDF_LIB            -L/opt/software/SGI/netcdf/4.1.3/lib -lnetcdf -lnetcdff 
+%FC                  ifort -lmpi
+%FCFLAGS             -r8 -O3 -automatic -static 
+%FFLAGS              %FCFLAGS   
+%LD                  %FC
+%FPPFLAGS            -P -C -traditional
 %LDFLAGS
-%FPPFLAGS            -P -C -traditional
-%AR                  ar
-%ARFLAGS             rs
+%AR                  ar 
+%ARFLAGS             -ruv
 %MK                  gmake
-%USER_INC            %NCDF_INC 
-%USER_LIB            %NCDF_LIB 
+%USER_INC            %NCDF_INC
+%USER_LIB            %NCDF_LIB
 
 # Flags only needed for IOSERVER
-%CC      mpicc
-%XIO_CFLAGS    -ansi -O3 -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279 -D BOOST_DISABLE_ASSERTS
-%XIO_FFLAGS    -O3 -DXIOS_LIBRARY 
-%XIO_LD         mpif90  -nofor-main
-%XIO_LDFLAGS        -lstdc++
-%XIO_INC       -D __NONE__
+%CC      icc
+%XIO_CFLAGS    -ansi -O3 -DNONE -DXIOS_LIBRARY -diag-disable 1125 -diag-disable 279 -D BOOST_DISABLE_ASSERTS -DMPI_NO_CPPBIND
+%XIO_FFLAGS    -O3 -DXIOS_LIBRARY
+%XIO_LD         ifort
+%XIO_LDFLAGS        -lstdc++ -lifcore -lintlc -lmpi    
+%XIO_INC       
 
-%XIO_CINC     -I$HDF5_INC_DIR -I$NETCDF_INC_DIR
+%XIO_CINC     -I/opt/software/SGI/hdf5/1.8.6/include  -I/opt/software/SGI/netcdf/4.1.3/include
 %XIO_FINC
-%XIO_LDINC     -L$(NETCDF_LIB_DIR) -L$HDF5_LIB_DIR   -lnetcdff -lnetcdf -lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl -lstdc++  
+%XIO_LDINC     -L/opt/software/SGI/netcdf/4.1.3/lib -L/opt/software/SGI/hdf5/1.8.6/lib   -lnetcdff -lnetcdf -lhdf5_hl -lhdf5 -lhdf5 -lz 
+
Index: /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/EXTERNAL/XIOS/bld.cfg
===================================================================
--- /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/EXTERNAL/XIOS/bld.cfg	(revision 3458)
+++ /branches/2012/dev_r3406_LOCEAN4_XIOS/NEMOGCM/EXTERNAL/XIOS/bld.cfg	(revision 3459)
@@ -32,5 +32,5 @@
 bld::tool::cpp       cpp
 bld::tool::cppflags  %XIO_INC -I${PWD}/extern/boost/include -I${PWD}/extern/rapidxml/include 
-bld::tool::fppflags  -std=c99 %XIO_INC -I${PWD}/extern/boost/include -I${PWD}/extern/rapidxml/include 
+bld::tool::fppflags  -P %XIO_INC -I${PWD}/extern/boost/include -I${PWD}/extern/rapidxml/include 
 bld::tool::ld        %XIO_LD
 bld::tool::ldflags   %XIO_LDFLAGS %XIO_LDINC