Index: /branches/2012/dev_r3438_LOCEAN15_PISLOB/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /branches/2012/dev_r3438_LOCEAN15_PISLOB/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 3460)
+++ /branches/2012/dev_r3438_LOCEAN15_PISLOB/NEMOGCM/NEMO/TOP_SRC/PISCES/P4Z/p4zfechem.F90	(revision 3461)
@@ -4,5 +4,5 @@
    !! TOP :   PISCES Compute iron chemistry and scavenging
    !!======================================================================
-   !! History :   3.5  !  2012-07     (O. Aumont, C. Ethe) Original code
+   !! History :   3.5  !  2012-07 (O. Aumont, A. Tagliabue, C. Ethe) Original code
    !!----------------------------------------------------------------------
 #if defined key_pisces
@@ -87,4 +87,5 @@
                        CALL wrk_alloc( jpi, jpj, jpk, zFe3, zFeL1, zTL1, ztotlig )
       IF( ln_fechem )  CALL wrk_alloc( jpi, jpj, jpk, zFe2, zFeL2, zTL2, zFeP )
+
       ! Total ligand concentration : Ligands can be chosen to be constant or variable
       ! Parameterization from Tagliabue and Voelker (2011)
@@ -106,28 +107,21 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  ! Calculate ligand concentrations : assume 2/3rd of excess goes to L2 and 1/3rd to L1
+                  ! Calculate ligand concentrations : assume 2/3rd of excess goes to
+                  ! strong ligands (L1) and 1/3rd to weak ligands (L2)
                   ztligand       = ztotlig(ji,jj,jk) - ligand * 1E9
-                  zTL2(ji,jj,jk) =                0.000001 + 0.67 * ztligand
-                  zTL1(ji,jj,jk) = ligand * 1E9 - 0.000001 + 0.33 * ztligand
+                  zTL1(ji,jj,jk) =                0.000001 + 0.67 * ztligand
+                  zTL2(ji,jj,jk) = ligand * 1E9 - 0.000001 + 0.33 * ztligand
                   ! ionic strength from Millero et al. 1987
                   zionic = 19.9201 * tsn(ji,jj,jk,jp_sal) / ( 1000. - 1.00488 * tsn(ji,jj,jk,jp_sal) + rtrn )
                   zph    = -LOG10( MAX( hi(ji,jj,jk), rtrn) )
                   zoxy   = trn(ji,jj,jk,jpoxy) * ( rhop(ji,jj,jk) / 1.e3 )
-! from Trapp and Millero (2007) corrected
-!                 zkox=(10.**( &
-!                   &     ((-.02*(zionic**.5)))-(3841/(tn &
-!                   &   (ji,jj,jk)+273.15))-(3.76*pH)+(0.33* &
-!                   &   pH**2)+(1.15*log10(carb))+27.87))* &
-!                   &   max(oxy,1.e-6) &
-!                   kox = kox * (60*24)
-                ! Fe2+ oxydation rate from Santana-Casiano et al. (2005)
-                  zkox = 35.407 - 6.7109 * zph + 0.5342 * zph * zph - 5362.6 / ( tsn(ji,jj,1,jp_tem) + 273.15 )  &
-                    &   - 0.04406 * SQRT( tsn(ji,jj,jk,jp_sal) ) - 0.002847 * tsn(ji,jj,jk,jp_sal)
-                  zkox = ( 10.** zkox ) * spd
-                  zkox = zkox * MAX( 1.e-6, zoxy) / ( chemo2(ji,jj,jk) + rtrn )
+                  ! Fe2+ oxydation rate from Santana-Casiano et al. (2005)
+                  zkox   = 35.407 - 6.7109 * zph + 0.5342 * zph * zph - 5362.6 / ( tsn(ji,jj,1,jp_tem) + 273.15 )  &
+                    &    - 0.04406 * SQRT( tsn(ji,jj,jk,jp_sal) ) - 0.002847 * tsn(ji,jj,jk,jp_sal)
+                  zkox   = ( 10.** zkox ) * spd
+                  zkox   = zkox * MAX( 1.e-6, zoxy) / ( chemo2(ji,jj,jk) + rtrn )
                   ! PHOTOREDUCTION of complexed iron : Tagliabue and Arrigo (2006)
-                  ! kph1=etot(ji,jj,jk)*0.0000001672*2.857142857143*spd modified to enhance
-                  zkph1 = MAX( 0., 15. * etot(ji,jj,jk) / ( etot(ji,jj,jk) + 2. ) )
-                  zkph2 = zkph1 / 5.
+                  zkph2 = MAX( 0., 15. * etot(ji,jj,jk) / ( etot(ji,jj,jk) + 2. ) )
+                  zkph1 = zkph2 / 5.
                   ! pass the dfe concentration from PISCES
                   ztfe = trn(ji,jj,jk,jpfer) * 1e9
@@ -156,15 +150,14 @@
                      ! zphi = ASINH( zq / ( 2. * zr * zr * zr ) )
                      zphi =  zq / ( 2. * zr * zr * zr ) 
-                     zphi = LOG( zphi + SQRT( zphi * zphi + 1 ) )  ! asinh(x) = log( x + sqrt( x*x + 1 ) )
+                     zphi = LOG( zphi + SQRT( zphi * zphi + 1 ) )  ! asinh(x) = log(x + sqrt(x^2+1))
                      zxs  = -2. * zr * SINH( zphi / 3. ) - za1 / 3.
                   ELSE
                      IF( zd > 0. ) THEN
                         zfff = MAX( 1., zq / ( 2. * zr * zr * zr ) )
-                      !  zphi = ACOSH( zfff )
-                        zphi = LOG( zfff + SQRT( zfff * zfff - 1 ) )  ! acosh(x) = log( x + sqrt( x*x - 1 ) )
+                        ! zphi = ACOSH( zfff )
+                        zphi = LOG( zfff + SQRT( zfff * zfff - 1 ) )  ! acosh(x) = log(x + sqrt(x^2-1))
                         zxs = -2. * zr * COSH( zphi / 3. ) - za1 / 3.
                      ELSE
-                        zfff = zq / ( 2. * zr * zr * zr )
-                        zfff = MIN( 1., zfff )
+                        zfff = MIN( 1., zq / ( 2. * zr * zr * zr ) )
                         zphi = ACOS( zfff )
                         DO jic = 1, 3
@@ -301,5 +294,5 @@
             CALL iom_put("TL1"    , zTL1   (:,:,:)       * tmask(:,:,:) )   ! TL1
             CALL iom_put("Totlig" , ztotlig(:,:,:)       * tmask(:,:,:) )   ! TL
-            CALL iom_put("Biron"  , biron  (:,:,:) * 1e9 * tmask(:,:,:) )   ! TL
+            CALL iom_put("Biron"  , biron  (:,:,:) * 1e9 * tmask(:,:,:) )   ! biron
             IF( ln_fechem ) THEN
                CALL iom_put("Fe2" , zFe2   (:,:,:)       * tmask(:,:,:) )   ! Fe2+
@@ -359,10 +352,15 @@
          con = 1.E9
          ! LIGAND KINETICS (values from Witter et al. 2000)
-         ! assume Phaeophytin
-         kl1 = 12.2E5  * spd / con
-         kb1 = 12.3E-6 * spd
-         ! Assume DFOB-like for L2
-         kl2 = 19.6e5  * spd / con
-         kb2 = 1.5e-6  * spd
+         ! Weak (L2) ligands
+         ! Phaeophytin
+         kl2 = 12.2E5  * spd / con
+         kb2 = 12.3E-6 * spd
+         ! Strong (L1) ligands
+         ! Saccharides
+         ! kl1 = 12.2E5  * spd / con
+         ! kb1 = 12.3E-6 * spd
+         ! DFOB-
+         kl1 = 19.6e5  * spd / con
+         kb1 = 1.5e-6  * spd
          ! pcp and remin of Fe3p
          ks  = 0.075
@@ -370,4 +368,5 @@
          ! thermal reduction of Fe3
          kth = 0.0048 * 24.
+         !
       ENDIF
       !